"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Token = void 0;
var Token = /** @class */ (function () {
    function Token(token, expiresAt) {
        var _this = this;
        this.token = token;
        this.expiresAt = expiresAt;
        this.toString = function () {
            if (_this.isExpired()) {
                throw new Error("token expired!");
            }
            return _this.token;
        };
        this.expireAtMillisecond = expiresAt.getTime() - 10000; // 10 second
    }
    Token.prototype.isExpired = function () {
        var now = Date.now();
        if (now >= this.expireAtMillisecond) {
            return true;
        }
        return false;
    };
    Token.prototype.getAsHeader = function () {
        if (this.isExpired()) {
            throw new Error("token expired!");
        }
        return {
            "X-Auth-Token": this.token,
        };
    };
    return Token;
}());
exports.Token = Token;
//# sourceMappingURL=token.js.map